/**
 * 验证手机号码
 验证规则：11位数字，以1开头。
 */

function checkMobile(str) {
	var regMobile = /^((17[\d])|(13[\d])|(15[\d])|(18[0-9])|(14[5,7]))\d{8}$/; 
	var re = new RegExp(regMobile);
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}

/**
 * 验证电话号码
 验证规则：区号+号码，区号以0开头，3位或4位
 号码由7位或8位数字组成
 区号与号码之间可以无连接符，也可以“-”连接
 如01088888888,010-88888888,0955-7777777
 */

function checkPhone(str) {
	var re = /^0\d{2,3}-?\d{7,8}$/;
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}

/**
 * 验证邮箱
 验证规则：姑且把邮箱地址分成“第一部分@第二部分”这样
 第一部分：由字母、数字、下划线、短线“-”、点号“.”组成，
 第二部分：为一个域名，域名由字母、数字、短线“-”、域名后缀组成，
 而域名后缀一般为.xxx或.xxx.xx，一区的域名后缀一般为2-4位，如cn,com,net，现在域名有的也会大于4位

 */
function checkEmail(str) {
	var re = /^(\w-*\.*)+@(\w-?)+(\.\w{2,})+$/
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}

/**
 * 校验密码
 * 请输入6-25个字母、数字、下划线构成的密码
 */
function checkPsw(str) {
	var re = /^(\w){6,20}$/;
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}
/**
 * 校验密码
 * 请输入6-25个字母、数字、下划线构成的密码
 */
function checkName(str) {
	var re = /^(\w){3,20}$/;
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}

/**
 * 校验4位验证码
 */

function checkCode(str) {
	var re = /^\d{4}$/;
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}

/**
 * 校验6位验证码
 */

function checkInviteCode(str) {
	var re = /^\d{6}$/;
	if (re.test(str)) {
		return true;
	} else {
		return false;
	}
}

/***** 判断是否为json对象 *******
 * @param obj: 对象（可以是jq取到对象）
 * @return isjson: 是否是json对象 true/false
 */
function isJson(obj) {
	var isjson = typeof (obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
	return isjson;
}

/**
 *生成防重发的随机字符串
 */
function getNoncestr() {
	var timer = new Date().getTime()+"";
	var b = new Base64();
	var c = b.encode(timer);
	return c.length > 32 ? c.substring(0, 32) : c;
}

/**
 *时间戳 构成的字符串 
 */
function getNoncestrNoBase64() {
	var timer = new Date().getTime()+"";
	return timer;
}